#!/usr/bin/env python

from deter import topdl

elems = []	# elements in the topology
subs = []	# substrates in the topology

# Create the center node and put it in the element list.  (Name is set
# explicitly)
center = topdl.Computer(name='center')
elems.append(center)

# Connect 10 satellites
for i in range(0,10):
    # Create a substrate to join the new element to center
    link = topdl.Substrate('link%d' % i)
    # Create the new element (n-i) and connect it to the new substrate with an
    # Interface object
    node = topdl.Computer(name='n-%d' % i, interface=[
	topdl.Interface(substrate=['link%d' %i])])
    # Add an interface to center linking it to the new substrate
    center.interface.append(topdl.Interface(substrate=['link%d' %i]))

    # Add the new link and node to the lists
    subs.append(link)
    elems.append(node)

# Create the topology from the lists.  This names the unnamed interfaces and
# makes connections.
top = topdl.Topology(elements=elems, substrates=subs)

# Print the XML
print topdl.topology_to_xml(top, top='experiment')

