#!/usr/bin/env python

import sys
from deter import topdl

# Parse the user-supplied routers and leaves arguments
try:
    if len(sys.argv) > 1: arg = sys.argv[1]
    else: arg = 4
    nrouters = int(arg)

    if len(sys.argv) > 2: arg = sys.argv[2]
    else: arg = 3
    nleaves = int(arg)

except ValueError, e:
    print >>sys.stderr, 'Usage %s routers leaves' % sys.argv[0]
    sys.exit('Cannot convert %s to an int' % arg)

elems = []	# Elements in the topology
subs = []	# Substrates in the topology

# Make nrouters routers
r = []
for i in range(0,nrouters):
    r.append(topdl.Computer(name='r-%d' % i))

elems.extend(r)
# Interconnect them
n = 0
for i in range(0,nrouters):
    for j in range(i+1, nrouters):
	# Connect r[i] to r[j]
	# Pick a substrate name
	link_name = 'rlink%i' % n
	# Add interfaces to the two routers
	r[i].interface.append(topdl.Interface(substrate=[link_name]))
	r[j].interface.append(topdl.Interface(substrate=[link_name]))
	# Put a substrate into the substrate list with the name we picked
	subs.append(topdl.Substrate(name=link_name))
	n += 1

# Put nleaves leaves on each router, except the center one
for i in range(0, (nrouters-1) * nleaves):
    # Pick a link name
    link_name = 'llink%i' % i

    # add a computer with an interface on the new substrate to the element list
    elems.append(topdl.Computer(name='leaf%d' % i, interface=[
	topdl.Interface(substrate=[link_name])]))

    # Add an interface to a router on the new substrate
    r[i/nleaves].interface.append(topdl.Interface(substrate=[link_name]))

    # Put a substrate into the substrate list with the name we picked
    subs.append(topdl.Substrate(name=link_name))

# Make the topology and print it
top = topdl.Topology(elements=elems, substrates=subs)
print topdl.topology_to_xml(top, top='experiment')
